Index: src/mlx/acft.py
===================================================================
--- src/mlx/acft.py	(revision 134)
+++ src/mlx/acft.py	(revision 136)
@@ -155,6 +155,8 @@
             elif newStage==const.STAGE_TAXIAFTERLAND:
                 bookedFlight = self._flight.bookedFlight
-                if bookedFlight.arrivalICAO=="LHBP" and \
-                   self._flight.config.isMessageTypeFS(const.MESSAGETYPE_GATE_SYSTEM):
+                config = self._flight.config
+                if config.onlineGateSystem and \
+                   bookedFlight.arrivalICAO=="LHBP" and \
+                   config.isMessageTypeFS(const.MESSAGETYPE_GATE_SYSTEM):
                     self._flight.getFleet(callback = self._fleetRetrieved,
                                           force = True)
Index: src/mlx/config.py
===================================================================
--- src/mlx/config.py	(revision 134)
+++ src/mlx/config.py	(revision 136)
@@ -37,4 +37,5 @@
 
         self._language = ""
+        self._onlineGateSystem = True
         self._flareTimeFromFS = False
         
@@ -92,4 +93,16 @@
         if language!=self._language:
             self._language = language
+            self._modified = True
+
+    @property
+    def onlineGateSystem(self):
+        """Get whether the online gate system should be used."""
+        return self._onlineGateSystem
+
+    @onlineGateSystem.setter
+    def onlineGateSystem(self, onlineGateSystem):
+        """Set whether the online gate system should be used."""
+        if onlineGateSystem!=self._onlineGateSystem:
+            self._onlineGateSystem = onlineGateSystem
             self._modified = True
 
@@ -163,4 +176,7 @@
 
         self._language = self._get(config, "general", "language", "")
+        self._onlineGateSystem = self._getBoolean(config, "general",
+                                                  "onlineGateSystem",
+                                                  True)
         self._flareTimeFromFS = self._getBoolean(config, "general",
                                                  "flareTimeFromFS",
@@ -194,4 +210,6 @@
         if self._language:
             config.set("general", "language", self._language)
+        config.set("general", "onlineGateSystem",
+                   "yes" if self._onlineGateSystem else "no")
         config.set("general", "flareTimeFromFS",
                    "yes" if self._flareTimeFromFS else "no")
Index: src/mlx/gui/flight.py
===================================================================
--- src/mlx/gui/flight.py	(revision 130)
+++ src/mlx/gui/flight.py	(revision 136)
@@ -413,10 +413,15 @@
         """Update the departure gate for the booked flight."""
         flight = self._wizard._bookedFlight
-        if flight.departureICAO=="LHBP":
-            self._wizard.getFleet(self._fleetRetrieved)
+        if self._wizard.gui.config.onlineGateSystem:
+            if flight.departureICAO=="LHBP":
+                self._wizard.getFleet(self._fleetRetrieved)
+            else:
+                self._wizard.updatePlane(self._planeUpdated,
+                                         flight.tailNumber,
+                                         const.PLANE_AWAY)
         else:
-            self._wizard.updatePlane(self._planeUpdated,
-                                     flight.tailNumber,
-                                     const.PLANE_AWAY)
+            self._nextDistance = 2
+            self._wizard.jumpPage(2)
+            
     def _fleetRetrieved(self, fleet):
         """Called when the fleet has been retrieved."""
@@ -1669,5 +1674,6 @@
     def _forwardClicked(self, button):
         """Called when the forward button is clicked."""
-        if not self._completed and \
+        if self._wizard.gui.config.onlineGateSystem and \
+           not self._completed and \
            self._wizard.bookedFlight.arrivalICAO=="LHBP":
             self._wizard.getFleet(callback = self._fleetRetrieved,
@@ -1868,5 +1874,6 @@
 
         self._gatesModel.clear()
-        if self._wizard.bookedFlight.arrivalICAO=="LHBP":
+        if self._wizard.gui.config.onlineGateSystem and \
+           self._wizard.bookedFlight.arrivalICAO=="LHBP":
             occupiedGates = self._wizard._fleet.getOccupiedGateNumbers()
             for gateNumber in const.lhbpGateNumbers:
@@ -1945,5 +1952,5 @@
         dialog.hide()
 
-        if returned and result.success:
+        if self._wizard.gui.config.onlineGateSystem and returned and result.success:
             bookedFlight = self._wizard.bookedFlight
             if bookedFlight.arrivalICAO=="LHBP":
Index: src/mlx/gui/prefs.py
===================================================================
--- src/mlx/gui/prefs.py	(revision 132)
+++ src/mlx/gui/prefs.py	(revision 136)
@@ -67,4 +67,5 @@
         """Setup the dialog from the given configuration."""
         self._setLanguage(config.language)
+        self._onlineGateSystem.set_active(config.onlineGateSystem)
         self._flareTimeFromFS.set_active(config.flareTimeFromFS)
 
@@ -89,4 +90,5 @@
         """Setup the given config from the settings in the dialog."""
         config.language = self._getLanguage()
+        config.onlineGateSystem = self._onlineGateSystem.get_active()
         config.flareTimeFromFS = self._flareTimeFromFS.get_active()
 
@@ -142,8 +144,12 @@
         self._warnedRestartNeeded = False
 
+        self._onlineGateSystem = gtk.CheckButton(xstr("prefs_onlineGateSystem"))
+        self._onlineGateSystem.set_use_underline(True)
+        self._onlineGateSystem.set_tooltip_text(xstr("prefs_onlineGateSystem_tooltip"))
+        mainBox.pack_start(self._onlineGateSystem, False, False, 4)
+
         self._flareTimeFromFS = gtk.CheckButton(xstr("prefs_flaretimeFromFS"))
         self._flareTimeFromFS.set_use_underline(True)
         self._flareTimeFromFS.set_tooltip_text(xstr("prefs_flaretimeFromFS_tooltip"))
-
         mainBox.pack_start(self._flareTimeFromFS, False, False, 4)
                                        
Index: src/mlx/i18n.py
===================================================================
--- src/mlx/i18n.py	(revision 132)
+++ src/mlx/i18n.py	(revision 136)
@@ -560,4 +560,9 @@
         self.add("prefs_lang_en_GB", "English")
         self.add("prefs_lang_hu_HU", "Hungarian")
+        self.add("prefs_onlineGateSystem",
+                 "_Use the Online Gate System")
+        self.add("prefs_onlineGateSystem_tooltip",
+                 "If this is checked, the logger will query and update the "
+                 "LHBP Online Gate System.")
         self.add("prefs_flaretimeFromFS",
                  "Take flare _time from the simulator")
@@ -1055,4 +1060,9 @@
         self.add("prefs_lang_en_GB", "angol")
         self.add("prefs_lang_hu_HU", "magyar")
+        self.add("prefs_onlineGateSystem",
+                 "Az Online _Gate System használata")
+        self.add("prefs_onlineGateSystem_tooltip",
+                 "Ha ezt bejelölöd, a logger lekérdezi és frissíti az "
+                 "LHBP Online Gate System adatait.")
         self.add("prefs_flaretimeFromFS",
                  "A ki_lebegtetés idejét vedd a szimulátorból")