Index: src/mlx/gui/common.py
===================================================================
--- src/mlx/gui/common.py	(revision 132)
+++ src/mlx/gui/common.py	(revision 144)
@@ -35,4 +35,13 @@
     JUSTIFY_CENTER = gtk.JUSTIFY_CENTER
 
+    CONTROL_MASK = gdk.CONTROL_MASK
+    SHIFT_MASK = gdk.SHIFT_MASK
+    BUTTON1_MASK = gdk.BUTTON1_MASK
+
+    SCROLL_UP = gdk.SCROLL_UP
+    SCROLL_DOWN = gdk.SCROLL_DOWN
+
+    SPIN_USER_DEFINED = gtk.SPIN_USER_DEFINED
+
     def text2unicode(text):
         """Convert the given text, returned by a Gtk widget, to Unicode."""
@@ -61,4 +70,13 @@
     WRAP_WORD = gtk.WrapMode.WORD
     JUSTIFY_CENTER = gtk.Justification.CENTER
+
+    CONTROL_MASK = gdk.ModifierType.CONTROL_MASK
+    SHIFT_MASK = gdk.ModifierType.SHIFT_MASK
+    BUTTON1_MASK = gdk.ModifierType.BUTTON1_MASK
+
+    SCROLL_UP = gdk.ScrollDirection.UP
+    SCROLL_DOWN = gdk.ScrollDirection.DOWN
+
+    SPIN_USER_DEFINED = gtk.SpinType.USER_DEFINED
 
     import codecs
Index: src/mlx/gui/flight.py
===================================================================
--- src/mlx/gui/flight.py	(revision 142)
+++ src/mlx/gui/flight.py	(revision 144)
@@ -1009,4 +1009,5 @@
         self._tankFigure.set_size_request(38, -1)
         self._tankFigure.set_visible_window(False)
+        self._tankFigure.set_tooltip_markup(xstr("fuel_tank_tooltip"))
 
         if pygobject:
@@ -1014,5 +1015,8 @@
         else:
             self._tankFigure.connect("expose_event", self._drawTankFigure)
-
+        self._tankFigure.connect("button_press_event", self._buttonPressed)
+        self._tankFigure.connect("motion_notify_event", self._motionNotify)
+        self._tankFigure.connect("scroll-event", self._scrolled)
+        
         alignment = gtk.Alignment(xalign = 0.5, yalign = 0.5,
                                   xscale = 0.0, yscale = 1.0)
@@ -1081,6 +1085,6 @@
         rectangleInnerLeft   = rectangleX0 + rectangleLineWidth
         rectangleInnerRight  = rectangleX1 - rectangleLineWidth
-        rectangleInnerTop    = rectangleY0 + rectangleLineWidth
-        rectangleInnerBottom = rectangleY1 - rectangleLineWidth
+        self._rectangleInnerTop = rectangleInnerTop = rectangleY0 + rectangleLineWidth
+        self._rectangleInnerBottom = rectangleInnerBottom = rectangleY1 - rectangleLineWidth
 
         rectangleInnerWidth = rectangleInnerRight - rectangleInnerLeft
@@ -1121,4 +1125,33 @@
         return True
 
+    def _setExpectedFromY(self, y):
+        """Set the expected weight from the given Y-coordinate."""
+        level = (self._rectangleInnerBottom - y) / \
+                (self._rectangleInnerBottom - self._rectangleInnerTop)
+        level = min(1.0, max(0.0, level))
+        self._expectedButton.set_value(level * self.capacity)
+        
+    def _buttonPressed(self, tankFigure, event):
+        """Called when a button is pressed in the figure.
+
+        The expected level will be set there."""
+        if event.button==1:
+            self._setExpectedFromY(event.y)
+        
+    def _motionNotify(self, tankFigure, event):
+        """Called when the mouse pointer moves within the area of a tank figure."""
+        if event.state==BUTTON1_MASK:            
+            self._setExpectedFromY(event.y)
+
+    def _scrolled(self, tankFigure, event):
+        """Called when a scroll event is received."""
+        increment = 1 if event.state==CONTROL_MASK \
+                    else 100 if event.state==SHIFT_MASK \
+                    else 10 if event.state==0 else 0
+        if increment!=0:
+            if event.direction==SCROLL_DOWN:
+                increment *= -1
+            self._expectedButton.spin(SPIN_USER_DEFINED, increment)
+        
     def _expectedChanged(self, spinButton):
         """Called when the expected value has changed."""
@@ -1153,10 +1186,10 @@
         self._pumpIndex = 0
 
-    def activate(self):
-        """Activate the page."""
-        gui = self._wizard.gui
-
-        self._setupTanks(gui.flight.aircraft.fuelTanks,
-                         self._wizard._fuelData)
+    # def activate(self):
+    #     """Activate the page."""
+    #     gui = self._wizard.gui
+
+    #     self._setupTanks(gui.flight.aircraft.fuelTanks,
+    #                      self._wizard._fuelData)
 
     def finalize(self):
@@ -2520,5 +2553,5 @@
             page.reset()
         
-        self.setCurrentPage(0)
+        self.setCurrentPage(6)
 
     def getFleet(self, callback, force = False):
Index: src/mlx/i18n.py
===================================================================
--- src/mlx/i18n.py	(revision 143)
+++ src/mlx/i18n.py	(revision 144)
@@ -306,4 +306,16 @@
         self.add("fuel_get_busy", "Querying fuel information...")
         self.add("fuel_pump_busy", "Pumping fuel...")
+        self.add("fuel_tank_tooltip",
+                 "This part displays the current level of the fuel in the "
+                 "compared to its capacity. The "
+                 '<span color="turquoise">turquoise</span> '
+                 "slider shows the level that should be loaded into the tank "
+                 "for the flight. You can click anywhere in the widget to "
+                 "move the slider there. Or you can grab it by holding down "
+                 "the left button of your mouse, and move the pointer up or "
+                 "down. The scroll wheel on your mouse also increments or "
+                 "decrements the amount of fuel by 10. If you hold down "
+                 "the <b>Shift</b> key while scrolling, the steps will be "
+                 "100, or with the <b>Control</b> key, 1.")
 
         self.add("route_title", "Route")
@@ -831,4 +843,16 @@
         self.add("fuel_get_busy", "Az üzemanyag lekérdezése...")
         self.add("fuel_pump_busy", "Az üzemanyag pumpálása...")
+        self.add("fuel_tank_tooltip",
+                 "Ez mutatja az üzemanyag szintjét a tartályban annak "
+                 "kapacitásához mérve. A "
+                 '<span color="turquoise">türkizkék</span> '
+                 "csúszka mutatja a repüléshez kívánt szintet. "
+                 "Ha a bal gombbal bárhová kattintasz az ábrán, a csúszka "
+                 "odaugrik. Ha a gombot lenyomva tartod, és az egérmutatót "
+                 "föl-le mozgatod, a csúszka követi azt. Az egered görgőjével "
+                 "is kezelheted a csúszkát. Alaphelyzetben az üzemanyag "
+                 "mennyisége 10-zel nő, illetve csökken a görgetés irányától "
+                 "függően. Ha a <b>Shift</b> billentyűt lenyomva tartod, "
+                 "növekmény 100, a <b>Control</b> billentyűvel pedig 1 lesz.")
 
         self.add("route_title", "Útvonal")