Index: src/mlx/gui/flight.py
===================================================================
--- src/mlx/gui/flight.py	(revision 144)
+++ src/mlx/gui/flight.py	(revision 145)
@@ -1002,4 +1002,5 @@
         label = gtk.Label("<b>" + name + "</b>")
         label.set_use_markup(True)
+        label.set_use_underline(True)
         label.set_justify(JUSTIFY_CENTER)
         label.set_alignment(0.5, 1.0)
@@ -1033,4 +1034,6 @@
         self._expectedButton.set_width_chars(5)
         self._expectedButton.connect("value-changed", self._expectedChanged)
+
+        label.set_mnemonic_widget(self._expectedButton)
 
         alignment = gtk.Alignment(xalign = 0.5, yalign = 0.5,
@@ -1186,10 +1189,10 @@
         self._pumpIndex = 0
 
-    # def activate(self):
-    #     """Activate the page."""
-    #     gui = self._wizard.gui
-
-    #     self._setupTanks(gui.flight.aircraft.fuelTanks,
-    #                      self._wizard._fuelData)
+    def activate(self):
+        """Activate the page."""
+        gui = self._wizard.gui
+
+        self._setupTanks(gui.flight.aircraft.fuelTanks,
+                         self._wizard._fuelData)
 
     def finalize(self):
@@ -2553,5 +2556,5 @@
             page.reset()
         
-        self.setCurrentPage(6)
+        self.setCurrentPage(0)
 
     def getFleet(self, callback, force = False):
Index: src/mlx/i18n.py
===================================================================
--- src/mlx/i18n.py	(revision 144)
+++ src/mlx/i18n.py	(revision 145)
@@ -294,14 +294,15 @@
                  "The amount of fuel tanked into your aircraft at the\n"
                  "beginning of the flight can be seen below.")
-        self.add("fuel_tank_centre", "Centre\n")
-        self.add("fuel_tank_left", "Left\n")
-        self.add("fuel_tank_right", "Right\n")
-        self.add("fuel_tank_left_aux", "Left\nAux")
-        self.add("fuel_tank_right_aux", "Right\nAux")
-        self.add("fuel_tank_left_tip", "Left\nTip")
+
+        self.add("fuel_tank_centre", "_Centre\n")
+        self.add("fuel_tank_left", "L_eft\n")
+        self.add("fuel_tank_right", "_Right\n")
+        self.add("fuel_tank_left_aux", "Left\nA_ux")
+        self.add("fuel_tank_right_aux", "Right\nAu_x")
+        self.add("fuel_tank_left_tip", "Left\n_Tip")
         self.add("fuel_tank_right_tip", "Right\nTip")
-        self.add("fuel_tank_external1", "External\n1")
-        self.add("fuel_tank_external2", "External\n2")
-        self.add("fuel_tank_centre2", "Centre\n2")
+        self.add("fuel_tank_external1", "External\n_1")
+        self.add("fuel_tank_external2", "External\n_2")
+        self.add("fuel_tank_centre2", "Ce_ntre\n2")
         self.add("fuel_get_busy", "Querying fuel information...")
         self.add("fuel_pump_busy", "Pumping fuel...")
@@ -831,14 +832,17 @@
                  "A repülés elején az egyes tartályokba tankolt\n"
                  "üzemanyag mennyisége lent látható.")
-        self.add("fuel_tank_centre", "Középső\n")
-        self.add("fuel_tank_left", "Bal\n")
-        self.add("fuel_tank_right", "Jobb\n")
-        self.add("fuel_tank_left_aux", "Bal\nkiegészítő")
-        self.add("fuel_tank_right_aux", "Jobb\nkiegészítő")
-        self.add("fuel_tank_left_tip", "Bal\nszárnyvég")
-        self.add("fuel_tank_right_tip", "Jobb\nszárnyvég")
-        self.add("fuel_tank_external1", "Külső\n1")
-        self.add("fuel_tank_external2", "Külső\n2")
-        self.add("fuel_tank_centre2", "Középső\n2")
+
+        # A B D E I G J K N O P S T V Y Z
+        
+        self.add("fuel_tank_centre", "Kö_zépső\n")
+        self.add("fuel_tank_left", "_Bal\n")
+        self.add("fuel_tank_right", "J_obb\n")
+        self.add("fuel_tank_left_aux", "Bal\nkie_gészítő")
+        self.add("fuel_tank_right_aux", "Jobb\nkiegészí_tő")
+        self.add("fuel_tank_left_tip", "B_al\nszárnyvég")
+        self.add("fuel_tank_right_tip", "Jobb\nszárn_yvég")
+        self.add("fuel_tank_external1", "Külső\n_1")
+        self.add("fuel_tank_external2", "Külső\n_2")
+        self.add("fuel_tank_centre2", "Közé_pső\n2")
         self.add("fuel_get_busy", "Az üzemanyag lekérdezése...")
         self.add("fuel_pump_busy", "Az üzemanyag pumpálása...")