Index: src/mlx/config.py
===================================================================
--- src/mlx/config.py	(revision 139)
+++ src/mlx/config.py	(revision 147)
@@ -37,4 +37,5 @@
 
         self._language = ""
+        self._hideMinimizedWindow = True
         self._onlineGateSystem = True
         self._onlineACARS = True
@@ -96,4 +97,16 @@
             self._modified = True
 
+    @property
+    def hideMinimizedWindow(self):
+        """Get whether a minimized window should be hidden."""
+        return self._hideMinimizedWindow
+
+    @hideMinimizedWindow.setter
+    def hideMinimizedWindow(self, hideMinimizedWindow):
+        """Set whether a minimized window should be hidden."""
+        if hideMinimizedWindow!=self._hideMinimizedWindow:
+            self._hideMinimizedWindow = hideMinimizedWindow
+            self._modified = True
+    
     @property
     def onlineGateSystem(self):
@@ -189,4 +202,7 @@
 
         self._language = self._get(config, "general", "language", "")
+        self._hideMinimizedWindow = self._getBoolean(config, "general",
+                                                     "hideMinimizedWindow",
+                                                     True)
         self._onlineGateSystem = self._getBoolean(config, "general",
                                                   "onlineGateSystem",
@@ -225,4 +241,6 @@
         if self._language:
             config.set("general", "language", self._language)
+        config.set("general", "hideMinimizedWindow",
+                   "yes" if self._hideMinimizedWindow else "no")
         config.set("general", "onlineGateSystem",
                    "yes" if self._onlineGateSystem else "no")
Index: src/mlx/gui/gui.py
===================================================================
--- src/mlx/gui/gui.py	(revision 142)
+++ src/mlx/gui/gui.py	(revision 147)
@@ -476,5 +476,7 @@
         iconified = gdk.WindowState.ICONIFIED if pygobject \
                     else gdk.WINDOW_STATE_ICONIFIED
-        if (event.changed_mask&iconified)!=0 and (event.new_window_state&iconified)!=0:
+        if self.config.hideMinimizedWindow and \
+           (event.changed_mask&iconified)!=0 and \
+           (event.new_window_state&iconified)!=0:
             self.hideMainWindow(savePosition = False)
 
Index: src/mlx/gui/prefs.py
===================================================================
--- src/mlx/gui/prefs.py	(revision 139)
+++ src/mlx/gui/prefs.py	(revision 147)
@@ -67,4 +67,5 @@
         """Setup the dialog from the given configuration."""
         self._setLanguage(config.language)
+        self._hideMinimizedWindow.set_active(config.hideMinimizedWindow)
         self._onlineGateSystem.set_active(config.onlineGateSystem)
         self._onlineACARS.set_active(config.onlineACARS)
@@ -91,4 +92,5 @@
         """Setup the given config from the settings in the dialog."""
         config.language = self._getLanguage()
+        config.hideMinimizedWindow = self._hideMinimizedWindow.get_active()
         config.onlineGateSystem = self._onlineGateSystem.get_active()
         config.onlineACARS = self._onlineACARS.get_active()
@@ -145,4 +147,9 @@
         self._changingLanguage = False
         self._warnedRestartNeeded = False
+
+        self._hideMinimizedWindow = gtk.CheckButton(xstr("prefs_hideMinimizedWindow"))
+        self._hideMinimizedWindow.set_use_underline(True)
+        self._hideMinimizedWindow.set_tooltip_text(xstr("prefs_hideMinimizedWindow_tooltip"))
+        mainBox.pack_start(self._hideMinimizedWindow, False, False, 4)
 
         self._onlineGateSystem = gtk.CheckButton(xstr("prefs_onlineGateSystem"))
Index: src/mlx/i18n.py
===================================================================
--- src/mlx/i18n.py	(revision 145)
+++ src/mlx/i18n.py	(revision 147)
@@ -595,4 +595,10 @@
         self.add("prefs_lang_en_GB", "English")
         self.add("prefs_lang_hu_HU", "Hungarian")
+        self.add("prefs_hideMinimizedWindow",
+                 "_Hide the main window when minimized")
+        self.add("prefs_hideMinimizedWindow_tooltip",
+                 "If checked, the main window will be hidden completely "
+                 "when minimized. You can still make it appear by "
+                 "clicking on the status icon or using its popup menu.")
         self.add("prefs_onlineGateSystem",
                  "_Use the Online Gate System")
@@ -1137,4 +1143,10 @@
         self.add("prefs_lang_en_GB", "angol")
         self.add("prefs_lang_hu_HU", "magyar")
+        self.add("prefs_hideMinimizedWindow",
+                 "A főablak _eltüntetése minimalizáláskor")
+        self.add("prefs_hideMinimizedWindow_tooltip",
+                 "Ha ezt kijelölöd, a főablak teljesen eltűnik, "
+                 "ha minimalizálod. A státuszikonra kattintással vagy annak "
+                 "menüje segítségével újra meg tudod jeleníteni.")
         self.add("prefs_onlineGateSystem",
                  "Az Online _Gate System használata")