Index: MLXMANIFEST
===================================================================
--- MLXMANIFEST	(revision 157)
+++ MLXMANIFEST	(revision 158)
@@ -3,5 +3,5 @@
 library/encodings/euc_jis_2004.pyc	1694	e12bbd059d4fd595cf4be5440ab439c2
 library/fnmatch.pyc	3414	4d50000f78e903598af06ef1c5cfb3ef
-library/gtk/_gtk.pyc	549	4ad4dc430e6ce8e8653f1236929a93f5
+library/gtk/_gtk.pyc	549	324e9bf59f307c6f34abcd2e105af2a6
 library/encodings/cp858.pyc	7591	02054a0b8e91b9758826eb70cddf096f
 library/encodings/cp1254.pyc	2678	17ff2ac86f90886d5c73ed789f0499f3
@@ -78,5 +78,5 @@
 library/gettext.pyc	14675	606ad2e00535dd0f4fee5bd8d8562b29
 library/random.pyc	24831	54b2048974a5c98912276ffa5dc637a9
-library/mlx/logger.pyc	4920	05da2d9bb59b448a10622c6afdf220ea
+library/mlx/logger.pyc	4911	6e05091ca671441f5e56a2f8afff02ed
 library/encodings/string_escape.pyc	1907	5856af6d4b4bbbe84b0595434afe8d34
 library/re.pyc	12699	5b157b40e294465c0f3d2ca82f70f66e
@@ -95,5 +95,5 @@
 library/encodings/iso2022_jp_2004.pyc	1723	66376e788f3819e781897268c1100986
 library/encodings/cp866.pyc	8103	f36418dcf93b17b3ced63bd544f44159
-library/gio/_gio.pyc	549	ce32f7e9e996c3318a29c33235f9b5ba
+library/gio/_gio.pyc	549	b623cbe0dd5f229d582bb55841557361
 library/encodings/cp437.pyc	7874	63f1278c0a66129c6fb4f504d6b61b66
 library/mimetools.pyc	7837	c9accd6ef795bf71c90630be0161cadc
@@ -123,5 +123,5 @@
 library/encodings/cp864.pyc	7999	ca90afae086cb6b8f69b8419cc3cd1cb
 library/pyexpat.pyd	152576	5a82e9ec95005aca6130751e5b961cc3
-library/pyexpat.pyc	546	5920fb1bc8d425a72e36a9c582760165
+library/pyexpat.pyc	546	e0bf8ea119e513f8a72142c6d04852e7
 library/unittest/loader.pyc	10884	591a785be23fba35582ce33bdd3d7acd
 library/ftplib.pyc	32043	5a1925388a0874e459aed6891f4cf0c1
@@ -157,5 +157,5 @@
 library/encodings/iso8859_10.pyc	2693	5e6cc8f721486ddbc1c99da285e13191
 library/mlx/config.pyc	12010	7a138f5b96c513912e8e0686f5c5fbaa
-library/atk.pyc	534	be5a116a6bc5c8735c9f35b8b6f4a8a3
+library/atk.pyc	534	fa86d691ae7b8d042fd5b3c33549cabe
 library/gio._gio.pyd	263168	acb8c95fdc391079bebdf7d8685b0dbc
 library/encodings/cp861.pyc	7868	c97a8970ce4d9f40cbafbea6576fbdca
@@ -176,5 +176,5 @@
 library/mlx/gui/gui.pyc	36341	6eeaa07fcbd8a89bf7e598087c666ee1
 library/stat.pyc	2503	d3b6dc7a54e705219f04d0be75a212de
-library/gobject/_gobject.pyc	573	af669d80f2b6327cda3cb40e3810c04d
+library/gobject/_gobject.pyc	573	a37d7d8cb4f70b0f09ab615b993ea70c
 library/encodings/utf_7.pyc	1747	2beeb059236527197d6c640396476ce8
 library/atexit.pyc	2083	595a09be339c73c3c02e378d99325d2a
@@ -184,5 +184,5 @@
 library/encodings/iso8859_1.pyc	2678	f09ec3b7f6a348cbd7f7286b60572bd0
 library/pangocairo.pyd	17920	5fc69a7d29a6d3127710c64de440daa4
-library/pangocairo.pyc	555	c8722df96bf6a7879e604e4f96abf71f
+library/pangocairo.pyc	555	9a662f4c2634358c694d6833a0553304
 library/sre.pyc	499	92bb633daa0bab6550ec0e3677673b5b
 library/tokenize.pyc	13565	354d02cd79df187a28c1851a1e3bad96
@@ -195,5 +195,5 @@
 library/gtk._gtk.pyd	1882624	bbb1d1e41bbebc6abf69bed719d50497
 library/_hashlib.pyd	287232	a1a18de0644f481749fcbcf26005eeaf
-library/_hashlib.pyc	549	7c8c9a8b98cdb0be7a837e8eefaf5a82
+library/_hashlib.pyc	549	b44386b428f16d1b172e6b57cbc6e8de
 library/copy.pyc	11674	30d1745c5e38ab170f8a0486fbebf305
 library/unittest/result.pyc	7444	aefbb3cc79c0ff17787ce84faed7f5e8
@@ -207,5 +207,5 @@
 library/ctypes/__init__.pyc	18846	2bd183962453ae93d6887b303d3fd338
 library/mlx/acars.pyc	1690	06ac9e4ad5cc96b831a3c69868e6145a
-library/cairo/_cairo.pyc	561	6d8f7f1f0a93c9903b1fa037b28c78c6
+library/cairo/_cairo.pyc	561	5785a244ecd7cfe65c2a27738ab4de48
 library/warnings.pyc	12666	9788b5f45765e8204e04c820f2711094
 library/encodings/iso2022_jp_1.pyc	1699	faed9d5747e982cec9fa8b3ad8e1de26
@@ -225,10 +225,10 @@
 library/bz2.pyd	76800	1ca9ececd2c84b80996fe632627f857f
 library/encodings/iso8859_16.pyc	2695	85e819a29dec2b601ce978dcd5a040fc
-library/bz2.pyc	534	3d77de5e2109543db1731163197759bf
+library/bz2.pyc	534	96169408e5e34b63e6395ee84d6400de
 library/email/utils.pyc	8840	a7be428df6fddee6121cfce55382d1f8
-library/_ssl.pyc	537	92ab12cb1ce06240a1e5ecb97e66a04d
+library/_ssl.pyc	537	daeef57719226ef9d0bc44ad8a6b06ed
 library/encodings/cp1250.pyc	2676	c92e287a2aa6a1c924df287d826aa3b7
 library/_ssl.pyd	720896	90826a140137efd0d806038828e16f8e
-library/pango.pyc	540	e4f80c51923532278c96f2bef1d8b920
+library/pango.pyc	540	1e5a976d1817680edb7c1c21ff48892d
 library/glib/__init__.pyc	187	d44c8c2772b263a36726ac0dcfc04b42
 library/pango.pyd	111616	c934763bdf125c3dc92b56db817001d4
@@ -250,5 +250,5 @@
 library/encodings/mbcs.pyc	1883	2213911a7dd0deada6799b63e18b695b
 library/unicodedata.pyd	688128	c856c31a03dc892e4f2aee93d0bfee44
-library/unicodedata.pyc	558	b2fba681a2aada099c871637b4101ca9
+library/unicodedata.pyc	558	b025c9579740ae143839a018b5da0e79
 library/encodings/cp1256.pyc	2675	c1bf26ed9c9b5ee0eec495138993cffb
 library/email/base64mime.pyc	5221	c536d6f0c03f029bba77f15ef6ba3d99
@@ -275,4 +275,5 @@
 library/share/locale/hu/LC_MESSAGES/gtk20.mo	58794	6ee4491ae7bc9d3dfb778578eb29a0b3
 library/email/__init__.pyc	2752	5e1a1ba649ac697d631b031987d09c33
+library/share/icons/hicolor/index.theme	22255	5138b82a57488ee821b8a38c2aa1420e
 library/glob.pyc	2238	d06c4386d18e2ab7f53fb866599403cc
 library/_threading_local.pyc	6424	9dfe88d58a5811d2d56347cc381ebf0a
@@ -308,14 +309,14 @@
 library/encodings/koi8_u.pyc	2686	b7e5a52eaaaf6b340075b40dc7596f42
 library/atk.pyd	208384	ebe7f0929eac23a3205d17d69906e172
-library/_ctypes.pyc	546	6c89ef9ae857bf8f48fc7e9da0d6f0fc
+library/_ctypes.pyc	546	9f86310b686c3061d75bdd32ec1f4ff8
 library/mlx/update.pyc	16214	1927a43ac4580370198b6d2f091f835f
 library/subprocess.pyc	38648	c9f749db06dfc9fb32079de51d6efd01
 library/encodings/utf_16_le.pyc	1854	dfa68705c26fd303adfc7ce3322166f2
 library/_socket.pyd	38400	5d273be76603399e88cf57f2605004bf
-library/_socket.pyc	546	189b1b321ab4d5b88d1a31f630334e58
+library/_socket.pyc	546	ba16b5802151bed5e05fe83d11f2b92c
 library/encodings/hex_codec.pyc	3520	a8b8d5b7c8810379c7007bcbc253951c
 library/tempfile.pyc	18526	e2cc2d63c29e15f20ee9325e790643a3
-library/glib/_glib.pyc	555	c79a13c714eb1b10ac2771c21d7854cf
-library/win32api.pyc	549	6153d81921ce994c09765e1b36e1375a
+library/glib/_glib.pyc	555	6157f7df91d682da07475a99f05d19b2
+library/win32api.pyc	549	d33834386641fd02adce67fe64a1cd2a
 library/encodings/iso8859_13.pyc	2696	f901ae0bbcfbb78f0c1783e89b2e2dc5
 library/zlib1.dll	100352	d90dad5eea33a178bac56fff2847d4c2
@@ -332,9 +333,9 @@
 library/encodings/cp875.pyc	2636	c72faa5d1cb6105ae81c971448fea479
 library/socket.pyc	15488	35f8eb455d6d8df8e19826d1dd7193f2
-library/select.pyc	543	bbac0009d04cc2bf8261d9c5a1f1fe38
+library/select.pyc	543	bde5d0dccea956e8408f692d35755f8b
 library/encodings/iso2022_jp.pyc	1683	40c2b92127f99452f84b250c2b4b2cda
 library/libgthread-2.0-0.dll	44287	7ad6f303082b382bff7bafbab246c61f
 library/select.pyd	11776	d90bf525f9f6c9c3aa6532fa6e569b4f
-library/pyuipc.pyc	543	4137395fef659d877474d7a9bd914b5c
+library/pyuipc.pyc	543	96b93d674c4f8ee6a8feac09af40b25f
 library/pyuipc.pyd	129220	58cdce7763687f456383c93fd3404d9f
 library/encodings/johab.pyc	1638	5346c11a863ffbcfb21aba8f1d2236b7