Index: MLXMANIFEST
===================================================================
--- MLXMANIFEST	(revision 158)
+++ MLXMANIFEST	(revision 166)
@@ -3,5 +3,5 @@
 library/encodings/euc_jis_2004.pyc	1694	e12bbd059d4fd595cf4be5440ab439c2
 library/fnmatch.pyc	3414	4d50000f78e903598af06ef1c5cfb3ef
-library/gtk/_gtk.pyc	549	324e9bf59f307c6f34abcd2e105af2a6
+library/gtk/_gtk.pyc	549	cce831fbbce661780e4aa4aee4005355
 library/encodings/cp858.pyc	7591	02054a0b8e91b9758826eb70cddf096f
 library/encodings/cp1254.pyc	2678	17ff2ac86f90886d5c73ed789f0499f3
@@ -12,5 +12,5 @@
 library/unittest/signals.pyc	2126	d574469ae3f8e3c3c6054c48e8ff6fe1
 library/pdb.pyc	41336	cca4477d622e897335b3f0cecb667ff4
-runmlx.exe	64000	8bcbc8f4c68b590c5ef010ad9580e1aa
+runmlx.exe	64000	488633e152c81c000e315cd0d74d6474
 library/xml/sax/xmlreader.pyc	17862	0362ded7016d21cdd85aea1170ebdda1
 library/encodings/latin_1.pyc	2111	52427573ccbfd06220b67d5a9dd1376e
@@ -58,6 +58,6 @@
 library/encodings/koi8_r.pyc	2700	fff1b35002b9e938b7ea6fd0fbe824ae
 library/mlx/gui/statusbar.pyc	4616	2909310114db08ca8d3162e70ef22519
-library/mlx/const.pyc	4972	de3904c521b27597d548bbc96ff14050
-library/mlx/fsuipc.pyc	53293	3e9f6032fd366882d0982f6fe4f48418
+library/mlx/const.pyc	4972	8b05e5b96077ed4c99eebd228f48db69
+library/mlx/fsuipc.pyc	53402	5c12463c240c8e90844490a9ff850168
 library/encodings/punycode.pyc	7570	335ff94e207934ae64e6f5fc07a5cacc
 library/encodings/shift_jisx0213.pyc	1710	1ec0383aafb1dcadb5f9b6afff16eb7f
@@ -95,5 +95,5 @@
 library/encodings/iso2022_jp_2004.pyc	1723	66376e788f3819e781897268c1100986
 library/encodings/cp866.pyc	8103	f36418dcf93b17b3ced63bd544f44159
-library/gio/_gio.pyc	549	b623cbe0dd5f229d582bb55841557361
+library/gio/_gio.pyc	549	014ddc5612d5ab5e06a303cfa0bcf0e9
 library/encodings/cp437.pyc	7874	63f1278c0a66129c6fb4f504d6b61b66
 library/mimetools.pyc	7837	c9accd6ef795bf71c90630be0161cadc
@@ -123,5 +123,5 @@
 library/encodings/cp864.pyc	7999	ca90afae086cb6b8f69b8419cc3cd1cb
 library/pyexpat.pyd	152576	5a82e9ec95005aca6130751e5b961cc3
-library/pyexpat.pyc	546	e0bf8ea119e513f8a72142c6d04852e7
+library/pyexpat.pyc	546	28db9f4e93d106aa021b40423032f06b
 library/unittest/loader.pyc	10884	591a785be23fba35582ce33bdd3d7acd
 library/ftplib.pyc	32043	5a1925388a0874e459aed6891f4cf0c1
@@ -130,5 +130,5 @@
 library/unittest/suite.pyc	9838	bf2c79bd4a6b6032f1ea53fa4908748f
 library/encodings/mac_arabic.pyc	7824	820deef79b02e1f7e52eb18e9be655bf
-library/mlx/gui/prefs.pyc	13030	3c3d1fe199deb11859b67dc920c0e13d
+library/mlx/gui/prefs.pyc	13053	0d5dbe8afbb8fab7b2be1840781e8db2
 library/encodings/tis_620.pyc	2748	5969b4db4f967b11ae7992cdfbf5890e
 library/encodings/cp855.pyc	8071	0a4259ba854c24186f2ce61d85883b4a
@@ -157,5 +157,5 @@
 library/encodings/iso8859_10.pyc	2693	5e6cc8f721486ddbc1c99da285e13191
 library/mlx/config.pyc	12010	7a138f5b96c513912e8e0686f5c5fbaa
-library/atk.pyc	534	fa86d691ae7b8d042fd5b3c33549cabe
+library/atk.pyc	534	fe3e307a78a9cc4bce684d7bdf816dff
 library/gio._gio.pyd	263168	acb8c95fdc391079bebdf7d8685b0dbc
 library/encodings/cp861.pyc	7868	c97a8970ce4d9f40cbafbea6576fbdca
@@ -174,7 +174,7 @@
 library/encodings/iso8859_6.pyc	2723	c8f9aa14a6a2ebf05d977317114bc65d
 library/libpango-1.0-0.dll	333729	5a14efd93ee27cfe960220fe4a904911
-library/mlx/gui/gui.pyc	36341	6eeaa07fcbd8a89bf7e598087c666ee1
+library/mlx/gui/gui.pyc	36364	2050500c35abdb515d17daf894d29320
 library/stat.pyc	2503	d3b6dc7a54e705219f04d0be75a212de
-library/gobject/_gobject.pyc	573	a37d7d8cb4f70b0f09ab615b993ea70c
+library/gobject/_gobject.pyc	573	891881fc921b55eb6436b850d5bf668a
 library/encodings/utf_7.pyc	1747	2beeb059236527197d6c640396476ce8
 library/atexit.pyc	2083	595a09be339c73c3c02e378d99325d2a
@@ -184,8 +184,8 @@
 library/encodings/iso8859_1.pyc	2678	f09ec3b7f6a348cbd7f7286b60572bd0
 library/pangocairo.pyd	17920	5fc69a7d29a6d3127710c64de440daa4
-library/pangocairo.pyc	555	9a662f4c2634358c694d6833a0553304
+library/pangocairo.pyc	555	f23a6733ab8c9132c1c6791714240df2
 library/sre.pyc	499	92bb633daa0bab6550ec0e3677673b5b
 library/tokenize.pyc	13565	354d02cd79df187a28c1851a1e3bad96
-library/mlx/gui/flight.pyc	85395	f5ec8303901df37eedc2c0667a087c07
+library/mlx/gui/flight.pyc	85418	86f3c4ba458413deabd618aa67421374
 library/lib/gtk-2.0/2.10.0/engines/libwimp.dll	97984	a5bbbe46e1363aba9020a76f2d58e9d6
 library/email/quoprimime.pyc	8590	f6c7a8ad81d44037dd074f4871053dab
@@ -195,5 +195,5 @@
 library/gtk._gtk.pyd	1882624	bbb1d1e41bbebc6abf69bed719d50497
 library/_hashlib.pyd	287232	a1a18de0644f481749fcbcf26005eeaf
-library/_hashlib.pyc	549	b44386b428f16d1b172e6b57cbc6e8de
+library/_hashlib.pyc	549	b0f9228e2299a7272830effaa43a4377
 library/copy.pyc	11674	30d1745c5e38ab170f8a0486fbebf305
 library/unittest/result.pyc	7444	aefbb3cc79c0ff17787ce84faed7f5e8
@@ -207,5 +207,5 @@
 library/ctypes/__init__.pyc	18846	2bd183962453ae93d6887b303d3fd338
 library/mlx/acars.pyc	1690	06ac9e4ad5cc96b831a3c69868e6145a
-library/cairo/_cairo.pyc	561	5785a244ecd7cfe65c2a27738ab4de48
+library/cairo/_cairo.pyc	561	6622b2b68a65815534f741644f28467a
 library/warnings.pyc	12666	9788b5f45765e8204e04c820f2711094
 library/encodings/iso2022_jp_1.pyc	1699	faed9d5747e982cec9fa8b3ad8e1de26
@@ -225,14 +225,14 @@
 library/bz2.pyd	76800	1ca9ececd2c84b80996fe632627f857f
 library/encodings/iso8859_16.pyc	2695	85e819a29dec2b601ce978dcd5a040fc
-library/bz2.pyc	534	96169408e5e34b63e6395ee84d6400de
+library/bz2.pyc	534	2dacc1f67ce6f4b8bef18fddbc30c9de
 library/email/utils.pyc	8840	a7be428df6fddee6121cfce55382d1f8
-library/_ssl.pyc	537	daeef57719226ef9d0bc44ad8a6b06ed
+library/_ssl.pyc	537	a5ad680df66cce9aa48b31a6396e6d12
 library/encodings/cp1250.pyc	2676	c92e287a2aa6a1c924df287d826aa3b7
 library/_ssl.pyd	720896	90826a140137efd0d806038828e16f8e
-library/pango.pyc	540	1e5a976d1817680edb7c1c21ff48892d
+library/pango.pyc	540	e3fcfc3d867e92c2c7416ef6dc684d58
 library/glib/__init__.pyc	187	d44c8c2772b263a36726ac0dcfc04b42
 library/pango.pyd	111616	c934763bdf125c3dc92b56db817001d4
 library/libgobject-2.0-0.dll	341594	356d697647a480562c4e2e921b13f8ed
-mlxupdate.exe	19456	d8eadc14204f8dd84f8ac703de608f02
+mlxupdate.exe	19456	e4a2240eacdc2647c90656899310c6f8
 library/email/errors.pyc	3229	cdb78ab237e195ad69f059128bc03b1d
 library/linecache.pyc	3091	666e6f81b0ea9a7637f8068493f738d5
@@ -250,5 +250,5 @@
 library/encodings/mbcs.pyc	1883	2213911a7dd0deada6799b63e18b695b
 library/unicodedata.pyd	688128	c856c31a03dc892e4f2aee93d0bfee44
-library/unicodedata.pyc	558	b025c9579740ae143839a018b5da0e79
+library/unicodedata.pyc	558	4289806e666e46e891fceb60a20b894e
 library/encodings/cp1256.pyc	2675	c1bf26ed9c9b5ee0eec495138993cffb
 library/email/base64mime.pyc	5221	c536d6f0c03f029bba77f15ef6ba3d99
@@ -309,14 +309,14 @@
 library/encodings/koi8_u.pyc	2686	b7e5a52eaaaf6b340075b40dc7596f42
 library/atk.pyd	208384	ebe7f0929eac23a3205d17d69906e172
-library/_ctypes.pyc	546	9f86310b686c3061d75bdd32ec1f4ff8
+library/_ctypes.pyc	546	3b2a84ea4d020180b585c738bf78cec1
 library/mlx/update.pyc	16214	1927a43ac4580370198b6d2f091f835f
 library/subprocess.pyc	38648	c9f749db06dfc9fb32079de51d6efd01
 library/encodings/utf_16_le.pyc	1854	dfa68705c26fd303adfc7ce3322166f2
 library/_socket.pyd	38400	5d273be76603399e88cf57f2605004bf
-library/_socket.pyc	546	ba16b5802151bed5e05fe83d11f2b92c
+library/_socket.pyc	546	7b1bd8f25e4e763ce7a2163c657aa4d3
 library/encodings/hex_codec.pyc	3520	a8b8d5b7c8810379c7007bcbc253951c
 library/tempfile.pyc	18526	e2cc2d63c29e15f20ee9325e790643a3
-library/glib/_glib.pyc	555	6157f7df91d682da07475a99f05d19b2
-library/win32api.pyc	549	d33834386641fd02adce67fe64a1cd2a
+library/glib/_glib.pyc	555	b1fd18ba441a3ec8e55f93ebe9aa659a
+library/win32api.pyc	549	3228c4576e9659f1af7ff11114e2a90c
 library/encodings/iso8859_13.pyc	2696	f901ae0bbcfbb78f0c1783e89b2e2dc5
 library/zlib1.dll	100352	d90dad5eea33a178bac56fff2847d4c2
@@ -330,12 +330,12 @@
 library/xml/sax/saxutils.pyc	12382	32ed045b3b520234ebea6a508a6569fe
 library/encodings/mac_turkish.pyc	2739	1682e228ddfd2e74e3ccaee0b65e7261
-library/mlx/pyuipc_sim.pyc	43532	fe15a7610a4058a4059a09bb2e91bccf
+library/mlx/pyuipc_sim.pyc	43607	eecadfd81467b977dc4a4ae2b05c487f
 library/encodings/cp875.pyc	2636	c72faa5d1cb6105ae81c971448fea479
 library/socket.pyc	15488	35f8eb455d6d8df8e19826d1dd7193f2
-library/select.pyc	543	bde5d0dccea956e8408f692d35755f8b
+library/select.pyc	543	7c963d4085711e3cb6cb745bf936ef58
 library/encodings/iso2022_jp.pyc	1683	40c2b92127f99452f84b250c2b4b2cda
 library/libgthread-2.0-0.dll	44287	7ad6f303082b382bff7bafbab246c61f
 library/select.pyd	11776	d90bf525f9f6c9c3aa6532fa6e569b4f
-library/pyuipc.pyc	543	96b93d674c4f8ee6a8feac09af40b25f
+library/pyuipc.pyc	543	2d50c10362e28900a8761a170f9c5061
 library/pyuipc.pyd	129220	58cdce7763687f456383c93fd3404d9f
 library/encodings/johab.pyc	1638	5346c11a863ffbcfb21aba8f1d2236b7